
public class Celda2D {

    int nP = 0;
    int[] par;
    pXY[] vecino = new pXY[9];
    pXY[] compens = new pXY[9];

    public Celda2D(int i, int j, int L){
		int a,b,c,cx,cy;
		c = 0;
		for(int ix = -1; ix <= 1; ++ix){
		    for(int iy = -1; iy <= 1; ++iy){
			a = i + ix;
			b = j + iy;
			cx = 0;
			cy = 0;
			if(a < 0){
			    a += L;
			    cx = -L;
			}
			if(a >= L){
			    a -= L;
			    cx = L;
			}
			if(b < 0){
			    b += L;
			    cy = -L;
			}
			if(b >= L){
			    b -= L;
			    cy = L;
			}
			vecino[c] = new pXY(a,b);
			compens[c] = new pXY(cx,cy);
			++c;
		    }
		}
    }
    public void setNP(int n){
    	nP = n;
    	par = new int[n];
    }
    public void setPar(int n, int m){
    	par[n] = m;
    }
    public int getNP(){
    	return nP;
    }
    public int getPar(int n){
    	return par[n];
    }
    public int getVecinoX(int n){
    	return vecino[n].getX();
    }
    public int getVecinoY(int n){
    	return vecino[n].getY();
    }
    public int getPhantomCompX(int n){
    	return compens[n].getX();
    }
    public int getPhantomCompY(int n){
    	return compens[n].getY();
    }
}

/* ***************************************** */
class pXY
{
    int X;
    int Y;
    public pXY(int x, int y){
		X = x;
		Y = y;
    }
    public int getX(){
    	return X;
    }
    public int getY(){
    	return Y;
    }
}
